(in-package #:odo/test)

(defun test-state-variable-implementation (fun)
  (dolist (tuple '((boolean test-boolean-domain *boolean-domain-tests*)
                   (integer test-integer-domain *integer-domain-tests*)
                   (real test-real-domain *real-domain-tests*)
                   (member test-enumerated-domain *enumerated-domain-tests*)))
    (iter
      (with (dom-type dom-tester test-list-name) = tuple)
      (for (dom-spec . results) in (symbol-value test-list-name))
      (for name = (gensym))
      (for var-spec = `(,(list* dom-type dom-spec)
                        :name ,name))
      (for var = (apply fun var-spec))
      (is (eql name (odo:name var)))
      (apply dom-tester (odo:range var)
             results))))
